var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Atom = void 0;
    var Atom = /** @class */ (function () {
        function Atom() {
        }
        // tslint:disable-next-line: ban-types
        Atom.superProperty = function (tc, target, name) {
            var c = tc;
            do {
                c = Object.getPrototypeOf(c);
                if (!c) {
                    throw new Error("No property descriptor found for " + name);
                }
                var pd = Object.getOwnPropertyDescriptor(c.prototype, name);
                if (!pd) {
                    continue;
                }
                return pd.get.apply(target);
            } while (true);
        };
        //      public static set(arg0: any, arg1: any, arg2: any): any {
        //     throw new Error("Method not implemented.");
        // }
        Atom.get = function (target, path) {
            var segments = path.split(".");
            for (var _i = 0, segments_1 = segments; _i < segments_1.length; _i++) {
                var iterator = segments_1[_i];
                if (target === undefined || target === null) {
                    return target;
                }
                target = target[iterator];
            }
            return target;
        };
        /**
         * Await till given milliseconds have passed
         * @param n
         * @param ct
         */
        Atom.delay = function (n, ct) {
            return new Promise(function (resolve, reject) {
                var h = {};
                h.id = setTimeout(function () {
                    // if (ct && ct.cancelled) {
                    //     reject(new Error("cancelled"));
                    //     return;
                    // }
                    resolve();
                }, n);
                if (ct) {
                    ct.registerForCancel(function () {
                        clearTimeout(h.id);
                        reject(new Error("cancelled"));
                    });
                }
            });
        };
        // // tslint:disable-next-line:member-access
        // static query(arg0: any): any {
        //     throw new Error("Method not implemented.");
        // }
        Atom.encodeParameters = function (p) {
            if (!p) {
                return "";
            }
            var s = "";
            for (var key in p) {
                if (p.hasOwnProperty(key)) {
                    var element = p[key];
                    var v = element;
                    if (v === undefined || v === null) {
                        continue;
                    }
                    if (v instanceof Date) {
                        v = v.toISOString();
                    }
                    else if (typeof element === "object") {
                        v = JSON.stringify(element);
                    }
                    if (s) {
                        s += "&";
                    }
                    s += key + "=" + encodeURIComponent(v);
                }
            }
            return s;
        };
        Atom.url = function (url, query, hash) {
            if (!url) {
                return url;
            }
            var p = this.encodeParameters(query);
            if (p) {
                if (url.indexOf("?") === -1) {
                    url += "?";
                }
                else {
                    url += "&";
                }
                url += p;
            }
            p = this.encodeParameters(hash);
            if (p) {
                if (url.indexOf("#") === -1) {
                    url += "#";
                }
                else {
                    url += "&";
                }
                url += p;
            }
            return url;
        };
        /**
         * Schedules given call in next available callLater slot and also returns
         * promise that can be awaited, calling `Atom.postAsync` inside `Atom.postAsync`
         * will create deadlock
         * @static
         * @param {()=>Promise<any>} f
         * @returns {Promise<any>}
         * @memberof Atom
         */
        Atom.postAsync = function (app, f) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                app.callLater(function () { return __awaiter(_this, void 0, void 0, function () {
                    var _a, error_1;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _b.trys.push([0, 2, , 3]);
                                _a = resolve;
                                return [4 /*yield*/, f()];
                            case 1:
                                _a.apply(void 0, [_b.sent()]);
                                return [3 /*break*/, 3];
                            case 2:
                                error_1 = _b.sent();
                                reject(error_1);
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); });
            });
        };
        Atom.designMode = false;
        return Atom;
    }());
    exports.Atom = Atom;
});
//# sourceMappingURL=Atom.js.map