var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../services/JsonService", "../services/ReferenceService", "./types"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AtomLoader = void 0;
    var JsonService_1 = require("../services/JsonService");
    var ReferenceService_1 = require("../services/ReferenceService");
    var types_1 = require("./types");
    var AtomLoader = /** @class */ (function () {
        function AtomLoader() {
        }
        AtomLoader.load = function (url, app) {
            return __awaiter(this, void 0, void 0, function () {
                var r, r, type, obj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (url.host === "reference") {
                                r = app.get(ReferenceService_1.default).get(url.path);
                                if (!r) {
                                    throw new Error("reference not found");
                                }
                                return [2 /*return*/, r.consume()];
                            }
                            if (url.host === "class") {
                                r = app.get(ReferenceService_1.default).get(url.path);
                                if (!r) {
                                    throw new Error("reference not found");
                                }
                                return [2 /*return*/, app.resolve(r.consume(), true)];
                            }
                            return [4 /*yield*/, types_1.DI.resolveViewClassAsync(url.path)];
                        case 1:
                            type = _a.sent();
                            if (!type) {
                                throw new Error("Type not found for " + url);
                            }
                            obj = app.resolve(type, true);
                            return [2 /*return*/, obj];
                    }
                });
            });
        };
        AtomLoader.loadView = function (url, app, hookCloseEvents, vmFactory) {
            return __awaiter(this, void 0, void 0, function () {
                var busyIndicator, view_1, vm, jsonService, key, element, k, rs, v, disposables_1, id_1, returnPromise;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            busyIndicator = app.createBusyIndicator();
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, , 3, 4]);
                            return [4 /*yield*/, AtomLoader.load(url, app)];
                        case 2:
                            view_1 = _a.sent();
                            vm = view_1.viewModel;
                            if (!vm) {
                                if (!vmFactory) {
                                    return [2 /*return*/, { view: view_1 }];
                                }
                                vm = vmFactory();
                                view_1.viewModel = vm;
                            }
                            if (vm) {
                                jsonService = app.get(JsonService_1.JsonService);
                                for (key in url.query) {
                                    if (url.query.hasOwnProperty(key)) {
                                        element = url.query[key];
                                        if (typeof element === "object") {
                                            vm[key] = jsonService.parse(jsonService.stringify(element));
                                            continue;
                                        }
                                        if (/^json\:/.test(key)) {
                                            k = key.split(":")[1];
                                            vm[k] = jsonService.parse(element.toString());
                                            continue;
                                        }
                                        if (/^ref\:/.test(key)) {
                                            rs = app.get(ReferenceService_1.default);
                                            v = rs.get(element);
                                            vm[key.split(":", 2)[1]] = v.consume();
                                            continue;
                                        }
                                        try {
                                            vm[key] = element;
                                        }
                                        catch (e) {
                                            // tslint:disable-next-line: no-console
                                            console.error(e);
                                        }
                                    }
                                }
                            }
                            // register hooks !! if it is a window !!
                            if (hookCloseEvents && vm) {
                                disposables_1 = view_1.disposables;
                                id_1 = (AtomLoader.id++).toString();
                                view_1.id = id_1;
                                returnPromise = new Promise(function (resolve, reject) {
                                    disposables_1.add(app.subscribe("atom-window-close:" + id_1, function (m, r) {
                                        resolve(r);
                                        view_1.dispose();
                                    }));
                                    disposables_1.add(app.subscribe("atom-window-cancel:" + id_1, function () {
                                        reject("cancelled");
                                        view_1.dispose();
                                    }));
                                });
                                // it is responsibility of view holder to dispose the view
                                // disposables.add((view as any));
                                vm.windowName = id_1;
                                view_1.returnPromise = returnPromise;
                                return [2 /*return*/, { view: view_1, disposables: disposables_1, returnPromise: returnPromise, id: id_1 }];
                            }
                            return [2 /*return*/, { view: view_1 }];
                        case 3:
                            busyIndicator.dispose();
                            return [7 /*endfinally*/];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        AtomLoader.id = 1;
        return AtomLoader;
    }());
    exports.AtomLoader = AtomLoader;
});
//# sourceMappingURL=AtomLoader.js.map